function [modulationVector] = buildModulationSignal(p_increaseStepsBy, p_repeatPatternNTimes, p_stableModLength)
% Modulation signal. Building the modulation vector ----------------------% 
    positivePhaseLength = p_stableModLength * p_increaseStepsBy;
    negativePhaseLength = p_stableModLength * p_increaseStepsBy;

    positivePhase = ones(positivePhaseLength,1);
    negativePhase = -ones(negativePhaseLength,1);
    shapeOfModulation = [positivePhase; negativePhase];
    
    modulationVector = repmat(shapeOfModulation, p_repeatPatternNTimes, 1)';