function createSPfigure(YMatrix1, yvector1, Y1, STEPS, p_maxWeight)
%CREATEFIGURE1(YMATRIX1,YVECTOR1,Y1)
%  YMATRIX1:  matrix of y data
%  YVECTOR1:  area yvector
%  Y1:  vector of y data

%  Auto-generated by MATLAB on 11-Feb-2011 12:56:14

% Create figure
figure1 = figure('Renderer','painters',...
    'PaperSize',[20.98404194812 29.67743169791],...
    'NumberTitle','off',...
    'Name','Experiment 1 Spiking model',...
    'Position',[0 0 1280 800],...
    'Color',[1 1 1]);

% Create axes
axes1 = axes('Parent',figure1,'XTickLabel',{'','','','','','',''},...
    'Units','pixels',...
    'Position',[80 285 1160 185],...
    'FontSize',22,...
    'FontName','Times New Roman');
% Uncomment the following line to preserve the X-limits of the axes
xlim(axes1,[0 STEPS]);
% Uncomment the following line to preserve the Y-limits of the axes
ylim(axes1,[-(p_maxWeight * 0.1) (p_maxWeight + (p_maxWeight * 0.1))]);
box(axes1,'on');
grid(axes1,'on');
hold(axes1,'all');

% Create multiple lines using matrix input to plot
plot1 = plot(YMatrix1,'Parent',axes1,'LineWidth',1);
set(plot1(1),'LineStyle','--','DisplayName','GABA-w');
set(plot1(2),'Color',[1 0 0],'DisplayName','GLU-w');

% Create ylabel
ylabel('Weight values','FontSize',22,'FontName','Times New Roman');

% Create legend
legend1 = legend(axes1,'show');
set(legend1,'Units','pixels');

% Create axes
axes2 = axes('Parent',figure1,'XTickLabel',{'','','','','','',''},...
    'Units','pixels',...
    'Position',[80 500 1160 185],...
    'FontSize',22,...
    'FontName','Times New Roman');
% Uncomment the following line to preserve the X-limits of the axes
xlim(axes2,[0 STEPS]);
% Uncomment the following line to preserve the Y-limits of the axes
ylim(axes2,[-1.2 1.2]);
box(axes2,'on');
grid(axes2,'on');
hold(axes2,'all');

% Create area
area(yvector1,'FaceColor',[0.701960802078247 0.780392169952393 1],...
    'Parent',axes2,...
    'DisplayName','Modulation');

% Create ylabel
ylabel('Modulation intensity','FontSize',22,'FontName','Times New Roman');

% Create axes
axes3 = axes('Parent',figure1,'Units','pixels','Position',[80 70 1160 185],...
    'FontSize',22,...
    'FontName','Times New Roman');
% Uncomment the following line to preserve the Y-limits of the axes
ylim(axes3,[-0.5 1.2]);
xlim(axes3,[0 STEPS]);

box(axes3,'on');
grid(axes3,'on');
hold(axes3,'all');

% Create plot
plot(Y1,'Parent',axes3,'DisplayName','output');

% Create ylabel
ylabel('Output value','FontSize',22,'FontName','Times New Roman');

% Create xlabel
xlabel('Simulation steps','FontSize',22,'FontName','Times New Roman');

