% Build modulation vector

if p_variableModLength == 0
    modulationVector = buildModulationSignal(p_increaseStepsBy, p_repeatPatternNTimes, p_stableModLength);
else
    modulationVector = buildVariableLengthModulationSignal(p_increaseStepsBy, p_repeatPatternNTimes, p_stableModLength, stream);
end

% Add noise to modulation vector
%modulatonVector = modulationVector + (rand(stream, 1, size(modulationVector,2)) .* 2 .* p_transmissionNoise) - p_transmissionNoise;

% Total steps in the simulation
p_STEPS = size(modulationVector,2);  

serviceVariablesCommon;

% Build high input signal
if (p_useSpikes == 1)
    highInput = generateSpikeTrain(p_probSpike, p_firingValue, p_notFiringValue, p_STEPS, stream, p_transmissionNoise);
    leakySensor = 0;
else
    highInput = ones(p_STEPS, 1) + rand(stream, p_STEPS, 1) * 2 * p_transmissionNoise - p_transmissionNoise;
end

% Initialisation ---------------------------------------------------------%

GLU_w(:,:,2)               = ones(p_nr_ins,p_nr_outs) .* p_maxWeight .* rand(stream, p_nr_ins, p_nr_outs);
GABA_w(:,:,2)              = ones(p_nr_ins,p_nr_outs) .* p_maxWeight .* rand(stream, p_nr_ins, p_nr_outs); 
s_step                     = 2;

% Simulation -------------------------------------------------------------%

disp(['Starting simulation']);
while (s_step <= p_STEPS);    

    sensor(1,1) = highInput(s_step);
    
    neuralComputation;
        
    modulation = modulationVector(s_step);
    
    plasticity;
    
    s_step = s_step + 1;
    
    if mod(s_step,p_STEPS/20) == 0
        disp([num2str(s_step/p_STEPS * 100) '% completed']);
    end
    
    
end

% Clear runtime variables ------------------------------------------------%
clear sensor;
clear matrixY
clear i;
clear j;
clear canFire;
clear modulation;
