% Agent simulation and modulation 

% The turn strength is proportional to the neural output
deltaAngle =  p_maxAngle * p_outputMapping * output(1,s_step);

if (wallContact == 0)
    angle = angle - deltaAngle;
end
    
if (angle < 0) angle = angle + 2*pi; end
if (angle > 2*pi) angle = angle - 2*pi; end

% Agent moves ------------------------------------------------------------%

    x0 = x0 + (cos(angle) * p_distPerStep);
    y0 = y0 + (sin(angle) * p_distPerStep);

    xL = x0 + ((p_objSensorDistanceFromBody) * cos(angle + p_objSensorAngle));
    yL = y0 + ((p_objSensorDistanceFromBody) * sin(angle + p_objSensorAngle));
    xR = x0 + ((p_objSensorDistanceFromBody) * cos(angle - p_objSensorAngle));
    yR = y0 + ((p_objSensorDistanceFromBody) * sin(angle - p_objSensorAngle));


% Bouncing back from walls -----------------------------------------------%

modulation = 0;

% OBJECT WALL
if (distW < 1 * p_sensorRange)
    % approaching is neg modulated, escaping is pos modulated.
     modulation =  (distW - distW_1) / (2*p_distPerStep);
     if modulation > 0 modulation = min(modulation, 1);end
end


wallContact = 0;
if (x0 <= 0) x0 = 0.02; wallContact = 1; end
if (x0 >= p_arenaWidth) x0 = p_arenaWidth - 0.02; wallContact = 1; end
if (y0 <= 0) y0 = 0.02; wallContact = 1; end
if (y0 >= 1) y0 = 1-0.02; wallContact = 1; end  
    
if (wallContact == 1) 
    modulation = p_negMod;
    % collision and slight rotation
    if sensor(1) > sensor(2)
        angle = angle - pi/6;
    else
        angle = angle + pi/6;
    end        

    if (angle < 0) angle = angle + 2*pi;end;
    if (angle > 2*pi) angle = angle - 2*pi;end
end

% OBJECT A
for i = 1:nr_A_objs
    distA_1(i) = distA(i);
    distA(i) = sqrt( abs( (x0 - xA(i))^2 + (y0 - yA(i))^2));

    if (distA(i) <  p_impactRange)  % object destroyed
        A_OffBoard(i) = 1;
    end
    if (distA(i) > 2 * p_sensorRange)     % onject restored
        A_OffBoard(i) = 0;
    end

    if (modulationPolicy == 1)
        if (distA(i) < 1 * p_sensorRange) && (A_OffBoard(i) == 0)
            % approaching is neg modulated, escaping is pos modulated.
             modulation = ( (distA(i) - distA_1(i))) / p_distPerStep;
           %  modulation = turnStrength; 
        end
    else
        if (distA(i) <  1 * p_sensorRange)  && (A_OffBoard(i) == 0);
            modulation = - ( (distA(i) - distA_1(i))) / p_distPerStep;
           % modulation = -turnStrength;
        end
    end       

end

% OBJECT B
if (p_nr_ins > 4)
    for i = 1:nr_B_objs
        distB_1(i) = distB(i);
        distB(i) = sqrt( abs( (x0 - xB(i))^2 + (y0 - yB(i))^2));
        if (distB(i) <  p_impactRange)
            % object destroyed
            B_OffBoard(i) = 1;
        end
        if (distB(i) > 2 * p_sensorRange)
            % object restored
            B_OffBoard(i) = 0;
        end

        if (modulationPolicy == 1)
            if (distB(i) < 1 * p_sensorRange) && (B_OffBoard(i) == 0)
                modulation = - ( (distB(i) - distB_1(i))) / p_distPerStep;
               % modulation = -turnStrength; 
            end
        else
            if (distB(i) < 1 * p_sensorRange) && (B_OffBoard(i) == 0)
                modulation = ( (distB(i) - distB_1(i))) / p_distPerStep;
                %modulation = turnStrength; 
           end
        end
    end
end

if modulation == 0; 
    modulation = p_posMod;
end


    
log_XYMod(:,s_step) = [x0 y0 modulation];

