% Frequently changed parameters determining the type of the experiment ---%

    p_totLives                    = 200;
    
    p_cycleLength                 = 12000;                                 % At each cycle the weights are reset to their average value. 
    
    p_STEPS                       = p_totLives * p_cycleLength;            % Total simulation steps
    
    p_policySwitch                = 1;                                     % 0/1 determines whether the policy is switched halfway through lifetime


    p_visualisationDelayStepBy    = 0.001;                                 % Delay in seconds between steps 

    p_plotEveryNrSteps            = 3;                                     % The arena plot is redrawn every give sim steps

    p_objectMoves                 = 0;                                     % Enable the procedure that makes object to move slowly around the arena during simulation
    
    p_visual                      = 1;                                     % If 0 no graphics will be displayed, otherwise the arena and simulation will be shown
    
    p_outputMapping               = 1;                                     % When inverted to -1, output signals have opposite effect.
    
    % Initial agent location in arena and heading
    x0 = rand(stream);
    y0 = rand(stream);
    angle = rand(stream) * 2 * pi; 
    
    x0 = 0.7;
    y0 = 0.3;
    angle = 1; 

% Stable parameters representing settings of the neural system and
% simulation environment -------------------------------------------------%

    p_sensorRange                 = 0.1;                                   % i.e. 10% of the arena, being the arena is 1by1

    p_objSensorAngle              = pi/2;                                  % i.e. obj sensors are at the side
    
    p_objSensorDistanceFromBody   = p_sensorRange * 0.5;                   % displacement of the obj sensors from the agent body

    p_distPerStep                 = 0.01;                                  % i.e. 1% of arena for each sim step

    p_negMod                      = -1;                                    % modulation during wall contact

    p_posMod                      = 0.1;                                   % modulation during non-wall-contanct

    % Maximum turning angle for maximum output
    p_maxAngle = pi/10;
    %p_maxAngle = pi/12; % 15deg
    %p_maxAngle = pi/15; % 12deg
    %p_maxAngle = pi/18; % 10deg
    %maxAngle = pi/20; % 9deg

    p_arenaWidth = 1.0;                                                    % Width of the arena

    p_impactRange = 0.025;                                                 % Within this distance the object is destroyed

    p_maxObjSpeed = 0.001;   

% Graphics ---------------------------------------------------------------%

    p_agentDrawRadius = .008;
    p_objDrawRadius = p_agentDrawRadius * 2;

% Object types, number and position --------------------------------------%
    objectsInit;
    