

% Draw static parts of the arena
if p_visual == 1
    drawArena;
end

%disp(['Press a key to start the simulation']);
%input('Press Enter to start the simulation');
%waitforbuttonpress;

tic;

while (s_step < p_STEPS) && (simulationEnded == 0)
    
    % During simulation, some changes (e.g the modulation policy) can be
    % enforced by adding conditions in this file
    onlineChanges;
    % Read all sensory information
    readSensorsInArena;
    % Compute output according to sensory information
    neuralComputation;
    % Move the agent in the environment according to the neural output, and
    % assign modulation values
    agentMoves;

    % Compute plasticity according to neural activity and modulation value
    plasticity;        
    
    % Redraw dynamic parts of the arena
    if (p_visual == 1) 
        if (mod(s_step,p_plotEveryNrSteps) == 0)
            drawArenaRefresh; 
        end
    else
        if mod(s_step,p_STEPS/20) == 0
            disp([num2str(s_step/p_STEPS * 100) '% completed']);
        end
    end
    % Increment simulation step by 1
    s_step = s_step + 1;
   
end
    