% Normally static parameters in the experiment might be required to change
% during online execution.
if simulationEnded ==0
    if p_visual == 1
        speedValue = round(get(graphRefresh, 'value'));
        
        switch speedValue
            case 0
                p_visualisationDelayStepBy = 0.5;
                p_plotEveryNrSteps = 1;
            case 1
                p_visualisationDelayStepBy = 0.2;
                p_plotEveryNrSteps = 1;
            case 2
                p_visualisationDelayStepBy = 0.2;
                p_plotEveryNrSteps = 2;
            case 3
                p_visualisationDelayStepBy = 0.1;
                p_plotEveryNrSteps = 2;
            case 4
                p_visualisationDelayStepBy = 0.01;
                p_plotEveryNrSteps = 3;
            case 5
                p_visualisationDelayStepBy = 0.001;
                p_plotEveryNrSteps = 4;
            case 6
                p_visualisationDelayStepBy = 0.0;
                p_plotEveryNrSteps = 5;
            case 7
                p_visualisationDelayStepBy = 0.0;
                p_plotEveryNrSteps = 6;
            case 8
                p_visualisationDelayStepBy = 0.0;
                p_plotEveryNrSteps = 7;
            case 9
                p_visualisationDelayStepBy = 0.0;
                p_plotEveryNrSteps = 8;
            otherwise
                p_plotEveryNrSteps = p_cycleLength - 1;
                p_visualisationDelayStepBy = 0.0;
        end
        
        if (get(u1, 'Value') == 1) && (p_policySwitch == 1)
            modulationPolicy = 1;
        end
        if (get(u2, 'Value') == 1) && (p_policySwitch == 1)
            modulationPolicy = 2;
        end
        
        
        if (get(ub0, 'Value') == 1)
            p_objectMoves = 0;
        else
            p_objectMoves = 1;
        end
        
    end
    
    % Change condition every n steps
    if (mod(s_step, p_cycleLength) == 0)
        if p_visual == 1
            alarmText = text(0.2,0.4,'Weights reset...');
        end
        % weights are reset to their average value
        resetWeights;
    end
    
    if p_visual == 1
        if (mod(s_step, p_cycleLength) == 100)
            if (exist('alarmText') == 1)
                delete(alarmText);
            end
        end
    end
    % Change condition every n steps (modulation policy change)
    if (mod(s_step, p_cycleLength) == p_cycleLength/2) && p_policySwitch == 1 %&& get(u1, 'Value') == 0 && get(u2, 'Value') == 0
        if modulationPolicy == 1
            modulationPolicy = 2;
        else
            modulationPolicy = 1;
        end
        
        if p_visual == 1
            alarmText = text(0.2,0.4,'Policy changed...');
        end
    end
    
    if p_visual == 1
        if (mod(s_step, p_cycleLength) == p_cycleLength/2 + 100)
            if (exist('alarmText') == 1)
                delete(alarmText);
            end
        end
    end
    
    % object move
    if p_objectMoves == 1
        objectsMove;
    end
end
