% Reading wall sensors ---------------------------------------------------%
    distLW = max([min([xL p_arenaWidth - xL yL 1 - yL]) 0]);
    distRW = max([min([xR p_arenaWidth - xR yR 1 - yR]) 0]);
    distW_1 = distW;
    distW = max([min([x0 p_arenaWidth - x0 y0 1 - y0]) 0]);
    wallSensor(1) = (p_sensorRange - min(distLW, p_sensorRange)) * 1/p_sensorRange;
    wallSensor(2) = (p_sensorRange - min(distRW, p_sensorRange)) * 1/p_sensorRange;

    
% Object distances -------------------------------------------------------%    
    sensorA(1:2) = 0;
    sensorB(1:2) = 0;

% Distances from objects A
for i = 1:nr_A_objs
    distLA(i) = sqrt(abs( (xL - xA(i))^2 + (yL - yA(i))^2));
    distRA(i) = sqrt(abs( (xR - xA(i))^2 + (yR - yA(i))^2));
end

for i = 1:nr_A_objs
    if (A_OffBoard(i) == 0)
        if (distLA(i) < p_sensorRange) 
            sensorA(1) = 1 - (distLA(i) / p_sensorRange);    
        end
        if (distRA(i) < p_sensorRange) 
            sensorA(2) = 1 - (distRA(i) / p_sensorRange);    
        end
    end
end

% Distances from objects B
for i = 1:nr_B_objs
    distLtoB(i) = sqrt(abs( (xL - xB(i))^2 + (yL - yB(i))^2));
    distRtoB(i) = sqrt(abs( (xR - xB(i))^2 + (yR - yB(i))^2));
end
for i = 1:nr_B_objs
    if (B_OffBoard(i) == 0)
        if (distLtoB(i) < p_sensorRange) 
            sensorB(1) = 1 - (distLtoB(i) / p_sensorRange);    
        end
        if (distRtoB(i) < p_sensorRange) 
            sensorB(2) = 1 - (distRtoB(i) / p_sensorRange);    
        end
    end
end

% Distances from objects C
for i = 1:nr_C_objs
    distLtoC(i) = sqrt(abs( (xL - xC(i))^2 + (yL - yC(i))^2));
    distRtoC(i) = sqrt(abs( (xR - xC(i))^2 + (yR - yC(i))^2));
end
    
for i = 1:nr_C_objs
    if (distLtoC(i) < p_sensorRange) 
        sensorC(1) = 1 - (distLtoC(i) / p_sensorRange);    
    end
    if (distRtoC(i) < p_sensorRange) 
        sensorC(2) = 1 - (distRtoC(i) / p_sensorRange);    
    end
end

% Distances from objects D
for i = 1:nr_D_objs
    distLtoD(i) = sqrt(abs( (xL - xD(i))^2 + (yL - yD(i))^2));
    distRtoD(i) = sqrt(abs( (xR - xD(i))^2 + (yR - yD(i))^2));
end
    
for i = 1:nr_D_objs
    if (distLtoD(i) < p_sensorRange) 
        sensorD(1) = 1 - (distLtoD(i) / p_sensorRange);    
    end
    if (distRtoD(i) < p_sensorRange) 
        sensorD(2) = 1 - (distRtoD(i) / p_sensorRange);    
    end
end

% Lateral inhibition. This is also equivalent to assume that
% the sensors are 180 degree omnidirectional (not 360) -------------------%
    if wallSensor(1) > wallSensor(2)    wallSensor(2) = 0;
    else  wallSensor(1) = 0; end

    if sensorA(1) > sensorA(2)  sensorA(2) = 0;
    else sensorA(1) = 0;  end
    if sensorB(1) > sensorB(2)
        sensorB(2) = 0;
    else
       sensorB(1) = 0;
    end
    if sensorC(1) > sensorC(2)
        sensorC(2) = 0;
    else
        sensorC(1) = 0;
    end
    if sensorD(1) > sensorD(2)
        sensorD(2) = 0;
    else
        sensorD(1) = 0;
    end

% Building vector of all sensors -----------------------------------------%

    if (p_nr_ins > 2) 
        sensor = [wallSensor sensorA'];
    end
    if (p_nr_ins > 4) 
        sensor = [sensor sensorB'];
    end

    % Addsing sesor noise 
    sensor = sensor +...
        (rand(stream, p_nr_ins, 1)' .* 2 .* p_transmissionNoise ) - p_transmissionNoise;  

% Write  log   
log_sensors(:,s_step) = sensor;