
tic;
for s_life = 1:p_totLives
    % start with equal weights at the beginning of a lifetime
    resetWeights;
    for s_session = 1:p_learningSessionsInLifetime
        % new targets at the start of a learning session
        targetSolutions = 2* (randi(stream,2,[p_nr_ins, p_nr_outs])-1.5);
  
        for s_scan = 1:p_scansInLearningSession
            
            for s_currentProblem = 1:p_nr_ins
                
                % activating the correct input
                sensor(s_currentProblem) = 1;
                
                neuralComputation;
                
                decision = sign(output(:,s_step));
                
                if decision == targetSolutions(s_currentProblem,:)';       % if correct
                    if p_stochasticMod == 1
                        modulation = p_weightUpdateRate * 1 * rand(stream,1) -.3;
                    else
                         modulation = p_weightUpdateRate * 1;
                    end
                else
                    if p_stochasticMod == 1
                        modulation = -1 *  p_weightUpdateRate * rand(stream,1) + .3;
                    else
                    modulation = p_weightUpdateRate * ...
                        -sum(abs(targetSolutions(s_currentProblem,:)' - decision))./(2 * p_nr_outs);
                    end
                end
                
                plasticity;
                
                % deactivate the input
                sensor(s_currentProblem) = 0;
                
                % Log modulation
                l_mod(s_life,s_session,s_scan,s_currentProblem) = modulation;
                
                s_step = s_step + 1;
                
                if mod(s_step,p_STEPS/100) == 0
                    disp([num2str(s_step/p_STEPS * 100) '% completed']);
                end
                
            end
        end
    end
end
