clear;

addpath common;

addpath exp1;

init;

p_variableModLength     = 1;
p_maxWeight             = 2;
p_useTanh               = 1;
p_tau                   = 1;
p_repeatPatternNTimes   = 4;

% User choices------------------------------------------------------------%

disp('Simulation parameters');

p_seedNumber = 1;
answer = input(['Random seed: [default  ' num2str(p_seedNumber) ']: ']);
if ~isempty(answer)
    p_seedNumber = answer;
end
stream = RandStream('mrg32k3a', 'Seed', p_seedNumber);
stream.reset;

p_useSpikes = 0;
answer = input(['Enter mode: Rate-base (0) or Spiking (1) [default ' num2str(p_useSpikes) ']: ']);
if ~isempty(answer)
    if (answer == 0 || answer == 1)
        p_useSpikes = answer;
    end
end
if (p_useSpikes == 1)
    p_repeatPatternNTimes = 6;
    p_tau                 = 10;
    p_increaseStepsBy     = 12;
    p_weightUpdateRate    = 1;
    p_maxWeight           = 2;
end

%Length in time steps of a phase where modulation does not change
p_stableModLength = 40;
answer = input(['Length of a modulation phase: [default ' num2str(p_stableModLength) ']: ']);
if ~isempty(answer)
    if answer > 0
        p_stableModLength = answer;
    end
end


answer = input(['Max weight [default ' num2str(p_maxWeight) ']: ']);
if ~isempty(answer)
    p_maxWeight = answer;
end

% The high and low periods of modulation are alternated n times
answer = input(['Number of modulatory cycles: [default ' num2str(p_repeatPatternNTimes) ']: ']);
if ~isempty(answer)
    if answer > 0 && answer < 100
        p_repeatPatternNTimes = answer;
    end
end

answer = input(['Transmission noise: [default  ' num2str(p_transmissionNoise) ']: ']);
if ~isempty(answer)
    p_transmissionNoise = answer;
end


% Launching --------------------------------------------------------------%
exp1;

% Plotting results -------------------------------------------------------%

matrixY = [squeeze(GABA_w(1,1,:)) squeeze(GLU_w(1,1,:))];

if p_useSpikes == 0
    createRBfigure(matrixY, modulationVector', output, p_STEPS,p_maxWeight);
else
    createSPfigure(matrixY, modulationVector', output, p_STEPS,p_maxWeight);
end

clear matrixY;
