disp('E1-Test : Random binomial distribution');
clear;

addpath common;
addpath exp1;

init;
tic;

p_variableModLength = 0;
p_stableModLength = 51;
p_nr_outs = 1;
p_randomReset = 1;

% User choices------------------------------------------------------------%

disp('Simulation parameters E1-Test');

% The high and low periods of modulation are alternated n times
p_repeatPatternNTimes = 10000;      

disp('Number of modulatory cycle'); 
disp('Warning: the test with a high number of cycles (> 1,000) takes several minutes to complete).');
answer = input(['[default ' num2str(p_repeatPatternNTimes) ']: ']);
if ~isempty(answer)
    if answer > 0
        p_repeatPatternNTimes = answer;
    end
end

p_seedNumber = 1;
answer = input(['Random seed: [default  ' num2str(p_seedNumber) ']: ']);
if ~isempty(answer)
    p_seedNumber = answer;
end
stream = RandStream('mrg32k3a', 'Seed', p_seedNumber);                 
stream.reset;

p_cycle = p_stableModLength * 2;

p_STEPS = p_cycle * p_repeatPatternNTimes;

setfive1 = zeros(1,p_repeatPatternNTimes/5);
setfive2 = zeros(1,p_repeatPatternNTimes/5);
setfive3 = zeros(1,p_repeatPatternNTimes/5);

% Start simulations ------------------------------------------------------%

p_transmissionNoise = 0.1;
disp(['Simulation of neural dynamics with high noise']);
exp1;
output1Bin = round((sign(output) + 1) / 2);

p_transmissionNoise = 0.02;
disp(['Simulation of neural dynamics with low noise']);
exp1;
output2Bin = round((sign(output) + 1) / 2);

p_transmissionNoise = 0.0;
disp(['Simulation of neural dynamics with no noise']);
exp1;
output3Bin = round((sign(output) + 1) / 2);


sequence1Bin = output1Bin(1,p_cycle/2:p_cycle:p_repeatPatternNTimes*p_cycle - p_cycle/2);
sequence2Bin = output2Bin(1,p_cycle/2:p_cycle:p_repeatPatternNTimes*p_cycle - p_cycle/2);
sequence3Bin = output3Bin(1,p_cycle/2:p_cycle:p_repeatPatternNTimes*p_cycle - p_cycle/2);


disp(['Sampling of 5-sets...']);
for i = 1:p_repeatPatternNTimes/5    
    setfive1(i) = bin2dec(num2str(sequence1Bin(1,1+5*(i-1):5+5*(i-1))));
end

disp(['Sampling of 5-sets...']);
for i = 1:p_repeatPatternNTimes/5    
    setfive2(i) = bin2dec(num2str(sequence2Bin(1,1+5*(i-1):5+5*(i-1))));
end

disp(['Sampling of 5-sets...']);
for i = 1:p_repeatPatternNTimes/5    
    setfive3(i) = bin2dec(num2str(sequence3Bin(1,1+5*(i-1):5+5*(i-1))));
end

createHist;

