clear;

addpath common;

addpath exp1;


p_repeatPatternNTimes = 2;                                                 % The high and low periods of modulation are alternated n times
p_variableModLength = 0;

init;
tic;

p_stableModLength = 21;
p_maxWeight = 1;
p_nr_outs = 1;
p_randomReset = 1;

% User choices------------------------------------------------------------%

disp('Simulation parameters for E1_Fig4AB');

p_seedNumber = 2;
answer = input(['Random seed: [default  ' num2str(p_seedNumber) ']: ']);
if ~isempty(answer)
    p_seedNumber = answer;
end
stream = RandStream('mrg32k3a', 'Seed', p_seedNumber);                 
stream.reset


% Start simulations ------------------------------------------------------%

p_transmissionNoise = 0.1;
disp(['Simulation of neural dynamics with high noise']);
exp1;
matrix1 = [squeeze(GABA_w(1,1,:)) squeeze(GLU_w(1,1,:))];

p_transmissionNoise = 0.0;
disp(['Simulation of neural dynamics with no noise']);
exp1;
matrix2 = [squeeze(GABA_w(1,1,:)) squeeze(GLU_w(1,1,:))];

createWClose(matrix2, matrix1);
