clear;

addpath common;

addpath exp1;

p_seedNumber = 2;

init;
tic;

p_stableModLength = 50;
p_cycle = p_stableModLength * 2;
p_variableModLength = 1;
p_nr_outs = 5;
p_randomReset = 1;
p_maxWeight = 5;

% User choices------------------------------------------------------------%

disp('Simulation parameters for E1_Fig4C_RoleOfNoise');

% The high and low periods of modulation are alternated n times
p_repeatPatternNTimes = 150;      

answer = input(['Number of modulatory cycle: [default ' num2str(p_repeatPatternNTimes) ']: ']);
if ~isempty(answer)
    if answer > 0
        p_repeatPatternNTimes = answer;
    end
end

answer = input(['Random seed: [default  ' num2str(p_seedNumber) ']: ']);
if ~isempty(answer)
    p_seedNumber = answer;
end
stream = RandStream('mrg32k3a', 'Seed', p_seedNumber);
stream.reset;


% Start simulations ------------------------------------------------------%

p_transmissionNoise = 0.01;
exp1;
output2Bin = round((sign(output) + 1) / 2);
output2Decimal = zeros(1,size(output,2));

p_transmissionNoise = 0.1;
exp1;
output3Bin = round((sign(output) + 1) / 2);
output3Decimal = zeros(1,size(output,2));

p_transmissionNoise = 0;
exp1;
output1Bin = round((sign(output) + 1) / 2);
output1Decimal = zeros(1,size(output,2));

disp('Extracting states...');

for i = 1:size(output1Decimal,2)
    output1Decimal(i) = bin2dec(num2str(output1Bin(:,i)'));
end
for i = 1:size(output2Decimal,2)
    output2Decimal(i) = bin2dec(num2str(output2Bin(:,i)'));
end
for i = 1:size(output3Decimal,2)
    output3Decimal(i) = bin2dec(num2str(output3Bin(:,i)'));
end

createNoiseOutputsfigure(output1Decimal(1,p_cycle/2:p_cycle:p_STEPS-p_cycle/2),...
    output2Decimal(1,p_cycle/2:p_cycle:p_STEPS-p_cycle/2),...
    output3Decimal(1,p_cycle/2:p_cycle:p_STEPS-p_cycle/2),...
    2^p_nr_outs);
