clear;

addpath common;
addpath exp1;

p_seedNumber        = 4;
p_variableModLength = 0;
p_stableModLength   = 40;
p_repeatPatternNTimes = 2;

init;

% User choices------------------------------------------------------------%

disp('Simulation parameters for E1_Fig5_RoleOfSaturation');

p_seedNumber = 4;
answer = input(['Random seed: [default  ' num2str(p_seedNumber) ']: ']);
if ~isempty(answer)
    p_seedNumber = answer;
end
stream = RandStream('mrg32k3a', 'Seed', p_seedNumber);
stream.reset;

answer = input(['Enter mode: Rate-base (0) or Spiking (1) [default ' num2str(p_useSpikes) ']: ']);
if ~isempty(answer)
    if (answer == 0 || answer == 1)
        p_useSpikes = answer;
    end
end

if (p_useSpikes == 1)
    p_useSig              = 0;
    p_tau                 = 30;
    p_increaseStepsBy     = 30;
    p_repeatPatternNTimes = 3;
end

% The high and low periods of modulation are alternated n times
answer = input(['Number of modulatory cycle: [default ' num2str(p_repeatPatternNTimes) ']: ']);
if ~isempty(answer)
    if answer > 0 && answer < 100
        p_repeatPatternNTimes = answer;
    end
end

answer = input(['Transmission noise: [default  ' num2str(p_transmissionNoise) ']: ']);
if ~isempty(answer)
    p_transmissionNoise = answer;
end

p_maxWeight = 50;
answer = input(['Max weight: [default  ' num2str(p_maxWeight) ']: ']);
if ~isempty(answer)
    p_maxWeight = answer;
end


% Launching --------------------------------------------------------------%

exp1;
matrix1 = [squeeze(GABA_w(1,1,:)) squeeze(GLU_w(1,1,:))];
createSatfigure(matrix1, modulationVector', output, p_STEPS);

clear matrix1;


