disp(['Braitenberg Vehicle Experiment']);

clear;

addpath common;                                                            % Location of the common files

addpath exp2;                                                              % Location of the files for Experiment 2
    
p_seedNumber = 1;                                                          % Seed for the pseudo-random number generation

init;                                                                      % Call the common-parameter initialisation

% Overwriting init settings for Experiment 2 -----------------------------%

    p_maxWeight           = 10;
    clear p_firingValue;
    clear p_notFiringValue;

    p_nr_ins              = 6;          % number of inputs of the network         

    p_useSpikes           = 0;          % navigation is tested here
                                        % with the rate based model

    p_useTanh             = 1;          % tanh is used instead of sigmoid

    p_tau                 = 1;          % tau 1 means that the neuron doesn't
                                        % have a continuous time dynamic
                                        % (no memory of the past
%-------------------------------------------------------------------------%
% Arena specific settings for agent simulation
arenaSettings;

disp('Example of one long lifetime (40,000 steps) to show the density plot');
disp('of the average location of the agent.');

    p_totLives = 1;
    p_cycleLength = 40000;
    p_policySwitch = 0;
    modulationPolicy = 1;
    p_visual = 0;
    p_STEPS                       = p_totLives * p_cycleLength;            % Total simulation steps
    modulationPolicy = 1;    


% Initialising common neural variables
serviceVariablesCommon;

% Initialising specific experiment variables
serviceVariablesE2;

main;

plotWeightsE2;

if p_totLives == 1 && p_policySwitch == 0
    plotNavigationProbDensity;
else
    plotModulation;
end

endSimulation;

