clear;

addpath common;                                                            % Location of the common files

addpath exp3;                                                              % Location of the files for Experiment 2

init;                                                                      % Call the common-parameter initialisation

% User choices -----------------------------------------------------------%


p_seedNumber = 2;                                                          % Seed for the pseudo-random number generation
answer = input(['Seed: [default ' num2str(p_seedNumber) ']: ']);
if ~isempty(answer)
    if answer > 0
        p_seedNumber = answer;
    end
end
stream = RandStream('mrg32k3a', 'Seed', p_seedNumber);
stream.reset;

p_nr_ins              = 3;          % number of inputs of the networks

answer = input(['Nr of inputs (problems): [default ' num2str(p_nr_ins) ', type 1 for plotting the weight change analysis (Fig.13)]: ']);
if ~isempty(answer)
    if answer > 0
        p_nr_ins = answer;
    end
end

p_nr_outs             = 3;          % number of inputs of the networks

answer = input(['Nr of outputs: [default ' num2str(p_nr_outs) ']: ']);
if ~isempty(answer)
    if answer > 0
        p_nr_outs = answer;
    end
end

p_scansInLearningSession     = 60;

answer = input(['Scans per learning session: [default '...
    num2str(p_scansInLearningSession) '], use at least 300 for stochastic modulation with 3 outputs: ']);
if ~isempty(answer)
    if answer > 0
        p_scansInLearningSession = answer;
    end
end

p_learningSessionsInLifetime = 4;

answer = input(['Learning sessions in a lifetime: [default '...
    num2str(p_learningSessionsInLifetime) ']: ']);
if ~isempty(answer)
    if answer > 0
        p_learningSessionsInLifetime = answer;
    end
end

p_totLives              = 100;
answer = input(['Lives: [default ' num2str(p_totLives) '], type 1 for plotting the weight change analysis (Fig 13): ']);
if ~isempty(answer)
    if answer > 0
        p_totLives = answer;
    end
end

p_stochasticMod         = 0;
answer = input(['Deterministic (0) or Stochastic (1) modulation: [default ' num2str(p_stochasticMod) ']: ']);
if ~isempty(answer)
    if answer > 0
        p_stochasticMod = answer;
    end
end


p_STEPS = p_nr_ins * p_scansInLearningSession * p_learningSessionsInLifetime * p_totLives;


p_useSpikes           = 0;          % navigation is tested here
% with the rate based model

p_useTan              = 1;          % tanh is used

p_tau                 = 1;          % tau 1 means that the neuron doesn't
% have a continuous time dynamic
% (no memory of the past)

p_maxWeight             = 2;

p_randomReset           = 0;
p_weightUpdateRate      = 1;
%-------------------------------------------------------------------------%


serviceVariablesE3;

serviceVariablesCommon;

mxn;

plotWeightsE3;